/*
 * Generated automatically by fh2h.pl
 * !!! DO NOT EDIT !!!
 * Edit the original fortran header file instead
 * or fix fh2h.pl if there is a translation bug.
 */


#ifndef FH2H_NEUTPARAMS_H
#define FH2H_NEUTPARAMS_H


#ifdef __cplusplus
extern "C" {
#endif


#ifndef IMPLICIT
#define IMPLICIT  /* Only to point out implicit types */
#endif


/*------ fortran header (without commons and data statements) ----------*/

/*************************************************************************/
/*     neutparams.h*/
/**/
/*     define NEUT parameter which is related to the*/
/*     fermi momentum and nuclear potential*/
/**/
/*---------------------------------------------------------*/
/**/
/*    PFSURF : Fermi srface momentum*/
/*               in (GeV)*/
/**/
/*    PFMAX  : Maximum value of the Fermi momentum */
/*                (usually, this value is same as PFSURF.)*/
/*               in (GeV)*/
/**/
/*    VNUINI : Nuclear potential (initial state) */
/*               Negative VALUE (GeV)*/
/**/
/*    VNUFIN : Nuclear potential (final state)*/
/*               Negative VALUE (GeV)*/
/**/
/*    IFORMLEN: FORMATION LENGTH effect ON/OFF*/
/*              IFORMLEN=   1  : ALL ON (default)*/
/*              IFORMLEN=   0  : ALL OFF*/
/*              IFORMLEN= 110  : OFF for QE/Elastic*/
/*              IFORMLEN= 100  : ON  for mPi/DIS only*/
/**/
/*    FZMU2     FORMATION ZONE FREE PARAMETER (SCAT MODEL, DEFAULT 0.08) */
/*---------------------------------------------------------*/
/**/
/*    FEFQE  : Correction Factor to the probability (p<500)*/
/*                              of quasielastic scattering ( single pi )*/
/*    FEFQEH : Correction Factor to the probability (p>500)*/
/*                              of quasielastic scattering ( single pi )*/
/**/
/*    FEFINEL: Correction Factor to the probability (p>500)*/
/*                              of hadron prod. (inel. scatter)*/
/**/
/*    FEFABS : Correction Factor to the probability (p<500)*/
/*                              of absorption*/
/**/
/*    FEFCOH : Correction Factor to the probability (p>500)*/
/*                              of coherent(forward)-scattering */
/**/
/*    FEFCX  : Correction Factor to the charge exchange amplitude (p<500)*/
/**/
/*    FEFCXH : Correction Factor to the charge exchange prob. (p>500)*/
/**/
/*    FEFQEHF: Portion of QE scattering that has isotropic resonance decay */
/*                              kinematics (p>500)*/
/**/
/*    FEFCOHF: Amount of forward (elastic) scatter relative */
/*                              to inelastic (p<500)*/
/**/
/*    FEFCXHF: Portion of inel. scattering that includes true CX (p>500)*/
/**/
/*    FEFCOUL: Coulomb correction to pion cascade trajectory (0: default, off)*/
/**/
/*    FEFALL:  Correction factor to the total mean free path (all momenta)*/
/**/
/*---------------------------------------------------------*/
/**/

/*common nenupr was here*/
/**/
/*---------------------------------------------------------*/
/**/

/*common neffpr was here*/


/*------ common blocks -------------------------------------------------*/

extern struct nenupr_common {
  float  pfsurf;
  float  pfmax;
  float  vnuini;
  float  vnufin;
  int    iformlen;
  float  fzmu2;
} nenupr_;
#ifndef NO_EXTERN_COMMON_POINTERS
extern struct nenupr_common *nenupr;
#endif
#ifdef STATIC_COMMON_POINTERS
static struct nenupr_common *nenupr = &nenupr_;
#endif

extern struct neffpr_common {
  float  fefqe;
  float  fefqeh;
  float  fefinel;
  float  fefabs;
  float  fefcoh;
  float  fefqehf;
  float  fefcohf;
  float  fefcx;
  float  fefcxhf;
  float  fefcxh;
  float  fefcoul;
  float  fefall;
} neffpr_;
#ifndef NO_EXTERN_COMMON_POINTERS
extern struct neffpr_common *neffpr;
#endif
#ifdef STATIC_COMMON_POINTERS
static struct neffpr_common *neffpr = &neffpr_;
#endif


/*------ data statements -----------------------------------------------*/


#ifndef NO_STATIC_DATA


#endif  /* #ifndef NO_STATIC_DATA */


/*------ end of fortran header -----------------------------------------*/


#ifdef __cplusplus
}
#endif


#endif  /* #ifndef FH2H_NEUTPARAMS_H */
