/*
 * Generated automatically by fh2h.pl
 * !!! DO NOT EDIT !!!
 * Edit the original fortran header file instead
 * or fix fh2h.pl if there is a translation bug.
 */


#ifndef FH2H_VCWORK_H
#define FH2H_VCWORK_H


#ifdef __cplusplus
extern "C" {
#endif


#ifndef IMPLICIT
#define IMPLICIT  /* Only to point out implicit types */
#endif


/*------ fortran header (without commons and data statements) ----------*/

/*-------------------------------------------------------------*/
/**/
/*     INCLUDE FILE FOR VECTOR GENERATOR ( vcwork.h )*/
/**/
/*     WORK AREA OF M.C. VECTOR GENERATOR*/
/**/
/*-------------------------------------------------------------*/
#define MAXVC (100)
/**/
/*     NVC         : # OF PARTICLE*/
/*     POSVC(3)    : VERTEX POSITION OF INITIAL INTERACTION*/
/*     IPVC(I)     : PARTICLE CODE OF I-TH PARTICLE*/
/*     AMASVC(I)   : MASS OF I-TH PARTICLE ( MEV/C**2 )*/
/*     PVC(3,I)    : MOMENTUM OF I-TH PARTICLE ( MEV/C )*/
/*     IORGVC(I)   : ID OF ORIGIN PARTICLE*/
/*     IFLGVC(I)   : FLAG OF FINAL STATE */
/*                   0 : DETERMINED LATER PROCEDURE*/
/*                   1 : DECAY TO OTHER PARTICLE*/
/*                   2 : ESCAPE FROM DETECTOR*/
/*                   3 : ABSORPTION*/
/*                   4 : CHARGE EXCHANGE*/
/*                   5 : STOP AND NOT CONSIDER IN M.C. */
/*                   6 : E.M. SHOWER*/
/*                   7 : HADRON PRODUCTION*/
/*                   8 : QUASI-ELASTIC SCATTER*/
/*                   9 : FORWARD (ELASTIC-LIKE) SCATTER*/
/*     ICRNVC(I)   : FLAG OF TO CHASE OR NOT*/
/*                   0 : DO NOT CHASE*/
/*                   1 : CHASE */
/*     TIMVC(I)    : TIME OF VERTEX*/
/*     POSIVC(3,I) : INITIAL VERTEX POSITION*/
/*     IVTIVC(I)   : ID OF INITIAL VERTEX*/
/*     POSFVC(3,I) : FINAL VERTEX POSITION*/
/*     IVTFVC(I)   : ID OF FINAL VERTEX*/
/**/
/*common vcwork was here*/



/*------ common blocks -------------------------------------------------*/

extern struct vcwork_common {
  int    nvc;
  float  posvc[3];
  int    ipvc[MAXVC];
  float  amasvc[MAXVC];
  float  pvc[MAXVC][3];
  int    iorgvc[MAXVC];
  int    iflgvc[MAXVC];
  int    icrnvc[MAXVC];
  float  timvc[MAXVC];
  float  posivc[MAXVC][3];
  int    ivtivc[MAXVC];
  float  posfvc[MAXVC][3];
  int    ivtfvc[MAXVC];
} vcwork_;
#ifndef NO_EXTERN_COMMON_POINTERS
extern struct vcwork_common *vcwork;
#endif
#ifdef STATIC_COMMON_POINTERS
static struct vcwork_common *vcwork = &vcwork_;
#endif


/*------ data statements -----------------------------------------------*/


#ifndef NO_STATIC_DATA


#endif  /* #ifndef NO_STATIC_DATA */


/*------ end of fortran header -----------------------------------------*/


#ifdef __cplusplus
}
#endif


#endif  /* #ifndef FH2H_VCWORK_H */
