/*
 * Generated automatically by fh2h.pl
 * !!! DO NOT EDIT !!!
 * Edit the original fortran header file instead
 * or fix fh2h.pl if there is a translation bug.
 */


#ifndef FH2H_NECARD_H
#define FH2H_NECARD_H


#ifdef __cplusplus
extern "C" {
#endif


#ifndef IMPLICIT
#define IMPLICIT  /* Only to point out implicit types */
#endif


/*------ fortran header (without commons and data statements) ----------*/

/*************************************************************************/
/*     --------*/
/*     NECARD.H*/
/*     --------*/
/**/
/*     (Purpose)*/
/*       COMMON for CARD on NEUT*/
/**/
/*     (Variables)*/
/*       NEFRMFLG : ( NEUT-FERM ) Flag on Fermi motion*/
/*                     0 : on ( default ) */
/*                     1 : off*/
/*       NEPAUFLG : ( NEUT-PAUL ) Flag on Pauli brokking*/
/*                     0 : on ( default ) */
/*                     1 : off*/
/*       NENEFO16 : ( NEUT-NEFF ) Flag on Nuclear effect in O16*/
/*                     0 : on ( default ) */
/*                     1 : off*/
/*       NENEFMODL: ( NEUT-MODL ) Select model for low energy pion*/
/*                     0 : default (Salcedo et. al)*/
/*                     1 : Tuned to pion scattering data*/
/*       NENEFMODH: ( NEUT-MODH ) Select model for high energy pion*/
/*                     0 : default*/
/*                     1 : proton/neutron separated*/
/*       NENEFKINH: ( NEUT-KINH ) Select kinematical model for */
/*                                   hi-nrg pion inelastic scattering*/
/*                     0 : Isotropic resonance decay*/
/*                     1 : SAID WI08 Phase Shifts*/
/*       neabspiemit : ( NEUT-neabspiemit ) Flag on Nucleon Ejection*/
/*                     0 : off */
/*                     1 : on ( default ) */
/*       NUSIM       : Neutrino Simulation Flag*/
/*                     1 : Neutrino Simulation   (default)*/
/*                     0 : Other (piscat, gampi)*/
/**/
/*       NEFKINVER   : VERSION of pion nuclear effects kinematics*/
/*                     0 : Original model ( default )*/
/*                       :  some part uses measured momentum spectrum of proton*/
/*                     1 : New model ( completely LFG for pion )*/
/**/
/*       NEMODFLG : ( NEUT-MODE ) Flag on Interaction mode on neutrino int.*/
/*                     0 : normal ( default )*/
/*                    -1 : input cross section by CRSNEUT*/
/*                     n : sellect one mode ( n > 0 )   See nemodsel.F*/
/*                           n =  1 : charged current Q.E. */
/*                           n = 11,12,13*/
/*                                  : charged current Single pi production */
/*                           n = 21 : charged current Multi pi production*/
/*                           n = 31,32,33,34*/
/*                                  : neutral current Single pi production */
/*                           n = 41 : neutral current Multi pi production*/
/*                           n = 51,52 : neutral current elastic*/
/*                           n = 22,42,43 : single eta production */
/*                           n = 23,44,45 : single  K  production */
/* */
/*       CRSNEUT(30)   : ( NEUT-CRS ) Multiplied factor to cross section*/
/*                                    on each mode.   See nemodsel.F*/
/*       CRSNEUTB(30)  : ( NEUT-CRSB ) Multiplied factor to cross section*/
/*                                    on each mode.   See nemodsel.F*/
/**/
/*       NECOHEPI      : ( NEUT_COHEPI ) Select Coherent pi model*/
/*                            0 : Rein & Sehgal*/
/*                            1 : Kartavtsev */
/*                            2 : Berger & Sehgal*/
/**/
/*       NEDIFPI      : ( NEUT_DIFPI ) Select Diffractive pi model*/
/*                            0 : Rein*/
/**/
/*       NEPDF         : ( NEUT-Select Parton distribution function*/
/*                           n = 7 : GRV94*/
/*                           n =12 : GRV98*/
/**/
/*       NEBODEK       : ( NEUT- urn off/on Bodek-Yang correction*/
/*                       0 :   off*/
/*                       1 :   on */
/**/
/*       NEMULT        : (Hadron multiplicity model for multi-pi mode)*/
/*                       0 :  old NEUT model*/
/*			1 :  fit of deuterium bubble-chamber data (hep-ph:1607.06558)*/
/*		        2 :  AGKY model (hep-ph:0904.4043 and Yang, T. et al. AIP Conf.Proc. 967 (2007) 269-275)*/
/**/
/*       ITAUFLGCORE  : control Tau run mode(this is not set here)*/
/**/
/*       NUMBNDN  : total number of neutron      (e.g. H2O => 8 , Fe => 30)*/
/*       NUMBNDP  : total number of bound proton (e.g. H2O => 8 , Fe => 26)*/
/*       NUMFREP  : total number of free proton  (e.g. H2O => 2 , Fe =>  0)*/
/*       NUMATOM  : atomic number                (e.g.   O =>16 , Fe => 56)*/
/**/
/*       IPILESSDCY: Pion less delta deacy             ( 1 : on / 0: off )*/
/*       RPILESSDCY: Fraction of pion less delta deacy ( default 0.2 )*/
/**/
/*       NEIFF:    Tells which form factors are used (see rsdcrs)*/
/*       NENRTYPE: For R-S form factors, there is two separate*/
/**/
/*       IRADCORR:  Radiative correction on/off ( 1 : on / 0: off )*/
/*                 ( Currently off by default )*/
/**/
/*       QUIET : Screen output verbosity*/
/*         0 : Default (prints all initial state info)*/
/*         1 : Print only neutrino energy*/
/*         2 : Prints almost nothing (except PYTHIA output)*/
/**/
/**/
/*     */
/*     (Creation Date and Author)*/
/*       1995.11.17 ; K.Kaneyuki*/
/*       1997.12.01 ; J.Kameda modify to consider eta*/
/*       1998.03.01 ; J.Kameda modify to consider  K*/
/*       2006.??.?? ; G.Mitsuka added NEPDF & NEBODEK */
/*       2006.12.30 ; Y.Hayato move flux /detector dependent part to*/
/*                              necardfx.h*/
/*       2007.01.08 ; G.Mitsuka add NECOHEPI*/
/*       2007.08.31 ; G.Mitsuka rename ITAUFLG to ITAUFLGCORE*/
/*                    not to conflict with neutflux*/
/*       2007.11.05 ; G.Mitsuka add target material information*/
/*       2010.06    ; P.de Perio - add model select for high energy pions*/
/*                               - add kinematical model select for high */
/*                                 energy pion inelastic scattering*/
/*       2012.12    ; P.Rodrigues added form factors*/
/**/
/*************************************************************************/

/*common neutcard was here*/

/*common nuceffver was here*/

/*common neutdis was here*/

/*common neut1pi was here*/

/*common neutdif was here*/

/*common neutcoh was here*/

/*common neuttarget was here*/

/*common neutpiabs was here*/

/*common neutpiless was here*/

/*common neutradcorr was here*/
                                                  


/*------ common blocks -------------------------------------------------*/

extern struct neutcard_common {
  int    nefrmflg;
  int    nepauflg;
  int    nenefo16;
  int    nenefmodl;
  int    nenefmodh;
  int    nenefkinh;
  int    nemodflg;
  int    neselmod;
  float  crsneut[30];
  float  crsneutb[30];
  int    itauflgcore;
  int    nusim;
  int    quiet;
} neutcard_;
#ifndef NO_EXTERN_COMMON_POINTERS
extern struct neutcard_common *neutcard;
#endif
#ifdef STATIC_COMMON_POINTERS
static struct neutcard_common *neutcard = &neutcard_;
#endif

extern struct nuceffver_common {
  int    nefkinver;
} nuceffver_;
#ifndef NO_EXTERN_COMMON_POINTERS
extern struct nuceffver_common *nuceffver;
#endif
#ifdef STATIC_COMMON_POINTERS
static struct nuceffver_common *nuceffver = &nuceffver_;
#endif

extern struct neutdis_common {
  int    nepdf;
  int    nebodek;
  int    nemult;
} neutdis_;
#ifndef NO_EXTERN_COMMON_POINTERS
extern struct neutdis_common *neutdis;
#endif
#ifdef STATIC_COMMON_POINTERS
static struct neutdis_common *neutdis = &neutdis_;
#endif

extern struct neut1pi_common {
  float  xmanffres;
  float  xmvnffres;
  float  xmarsres;
  float  xmvrsres;
  int    neiff;
  int    nenrtype;
  float  rneca5i;
  float  rnebgscl;
} neut1pi_;
#ifndef NO_EXTERN_COMMON_POINTERS
extern struct neut1pi_common *neut1pi;
#endif
#ifdef STATIC_COMMON_POINTERS
static struct neut1pi_common *neut1pi = &neut1pi_;
#endif

extern struct neutdif_common {
  int    nedifpi;
} neutdif_;
#ifndef NO_EXTERN_COMMON_POINTERS
extern struct neutdif_common *neutdif;
#endif
#ifdef STATIC_COMMON_POINTERS
static struct neutdif_common *neutdif = &neutdif_;
#endif

extern struct neutcoh_common {
  int    necohepi;
} neutcoh_;
#ifndef NO_EXTERN_COMMON_POINTERS
extern struct neutcoh_common *neutcoh;
#endif
#ifdef STATIC_COMMON_POINTERS
static struct neutcoh_common *neutcoh = &neutcoh_;
#endif

extern struct neuttarget_common {
  int    numbndn;
  int    numbndp;
  int    numfrep;
  int    numatom;
} neuttarget_;
#ifndef NO_EXTERN_COMMON_POINTERS
extern struct neuttarget_common *neuttarget;
#endif
#ifdef STATIC_COMMON_POINTERS
static struct neuttarget_common *neuttarget = &neuttarget_;
#endif

extern struct neutpiabs_common {
  int    neabspiemit;
} neutpiabs_;
#ifndef NO_EXTERN_COMMON_POINTERS
extern struct neutpiabs_common *neutpiabs;
#endif
#ifdef STATIC_COMMON_POINTERS
static struct neutpiabs_common *neutpiabs = &neutpiabs_;
#endif

extern struct neutpiless_common {
  int    ipilessdcy;
  float  rpilessdcy;
} neutpiless_;
#ifndef NO_EXTERN_COMMON_POINTERS
extern struct neutpiless_common *neutpiless;
#endif
#ifdef STATIC_COMMON_POINTERS
static struct neutpiless_common *neutpiless = &neutpiless_;
#endif

extern struct neutradcorr_common {
  int    iradcorr;
} neutradcorr_;
#ifndef NO_EXTERN_COMMON_POINTERS
extern struct neutradcorr_common *neutradcorr;
#endif
#ifdef STATIC_COMMON_POINTERS
static struct neutradcorr_common *neutradcorr = &neutradcorr_;
#endif


/*------ data statements -----------------------------------------------*/


#ifndef NO_STATIC_DATA


#endif  /* #ifndef NO_STATIC_DATA */


/*------ end of fortran header -----------------------------------------*/


#ifdef __cplusplus
}
#endif


#endif  /* #ifndef FH2H_NECARD_H */
