/*
 * Generated automatically by fh2h.pl
 * !!! DO NOT EDIT !!!
 * Edit the original fortran header file instead
 * or fix fh2h.pl if there is a translation bug.
 */


#ifndef FH2H_NEUTMODEL_H
#define FH2H_NEUTMODEL_H


#ifdef __cplusplus
extern "C" {
#endif


#ifndef IMPLICIT
#define IMPLICIT  /* Only to point out implicit types */
#endif


/*------ fortran header (without commons and data statements) ----------*/

/**/
/*-- Model for QE*/
/*  MDLQE   = XX1 ; CC : Smith-Moniz cross-section with classical kinematics*/
/*            XX2 ; CC : Smith-Moniz cross-section with classical kinematics*/
/*                      ( BBBA05 vector form factor )*/
/**/
/*          = X0X ; NC : Original code*/
/*          = X1X ; NC : Dipole*/
/*          = X2X ; NC : BBBA05 calculation*/
/**/
/*          = 0XX ; ALL; No correction on GM form factor*/
/*          = 1XX ; ALL; Correction on GM form factor ( Bodek et al )*/
/*          */
/*          *** 4XX, 6XX and 7XX ignores the 1st and 2nd digits ****/
/**/
/*          = 4XX ; ALL; Use SF nuclear model for kinematics*/
/*          = 6XX ; ALL; Use Effective SF nuclear model for kinematics*/
/*          = 7XX ; ALL; Use TEM-effective SF nuclear model for kinematics*/
/**/
/*          =1xxx ; apply RPA correction*/
/**/
/*          *** 2XXX ignores 1st, 2nd and 3rd digits*/
/*          =2xxx ; Nieves LFG*/
/**/
/**/
/*-- Axial form factor for QE*/
/*  MDLQEAF = 1 ; Simple dipole form factor*/
/*  MDLQEAF = 0;  BBBA07*/
/**/
/*-- MA (MV) value of QE*/
/*  XMAQE (XMVQE)*/
/**/
/*-- Kappa factor for QE (ala MiniBooNE)*/
/*  KAPP*/
/**/
/*-- MA value of NCEL*/
/*  XMANCEL*/
/**/
/*-- Nieves CCQE flags */
/**/
/*-- Use Bidning energy or not*/
/**/
/*  NVQEBIND =1 ; Binding energy != 0*/
/*  NVQEBIND =0 ; Binding energy == 0*/
/**/
/*-- RFG or not*/
/**/
/*  NVQERFG = 0 ; default : ( not used )*/
/*               */
/*-- Turn on / off RPA*/
/*  NVQERPA =1 ; With RPA correction*/
/*  NVQERPA =0 ; Without RPA correction*/
/*                 */
/*-- RPA correction parameters*/
/*  NVRPAFP0IN     = 0.33*/
/*  NVRPAPF0EX     = 0.45*/
/*  NVRPAF         = 1*/
/*  NVRPAFSTAR     = 2.13*/
/*  NVRPAPILAMBDA  = 1200.*/
/*  NVRPACR0       = 2.0*/
/*  NVRPARHOLAMBDA = 2500.*/
/*  NVRPAGP        = 0.63*/
/*  NVRPAXMPI      = 139.57*/
/*  NVRPAXMRHO     = 770.0*/
/*  NVRPAIREL      = 1.*/
/*  */
/*-- FermiMomentum used in SF model only (for pauli blocking)*/
/*-- (if user doesn't define, uses default for nucleus)*/
/*  PFSF*/
/**/
/*-- Second class form factors for CCQE (both 0.0 as default)*/
/*  SCCFV*/
/*  SCCFA*/
/**/
/*-- Error term for pseudoscalar form factor for CCQE*/
/*  QEFP*/
/**/
/*-- Model for 2p2h interaction*/
/*  MDL2P2H = 1 ; Nieves model with table*/
/*  MDL2P2H = 2 ; Nieves model with hadron tensor*/
/**/
/*-- Model for Single pion production*/
/*  MDLSPI = 1 ; Rein Sehgal*/
/**/
/*-- MA (MV) for Rein-Sehgal Single meson production*/
/*  XMARSRES (XMVRSRES)*/
/**/
/*-- MA for New Form factor Single meson production*/
/*  XMANFFRES (XMVNFFRES)*/
/**/
/*-- Coherent pion*/
/*  MDLCOH = 0 ; Rein&Sehgal w/ lepton mass corr.*/
/*           1 ; Kartavtsev et al.*/
/*           2 ; Berger&Sehgal	*/
/**/
/*  XMACOH  (Default = 1.0)*/
/*  RAD0NU  (Default = 1 fm)*/
/*  fA1COH  (Default = 0.0)*/
/*  fb1COH  (Default = 0.0)*/
/**/
/*-- DIS*/
/*  MODELDIS = 70 ; GRV94 Original*/
/*             71 ; GRV94 Bodek*/
/*            120 ; GRV98 Original*/
/*            121 ; GRV98 Bodek*/
/**/
/*-- Diffractive pion*/
/*  MDLDIF = 0 ; Rein&Sehgal w/ lepton mass corr.*/
/**/
/*  XMADIF  (Default = 1.1)*/
/*  NUCVOLDIF  (Default = 7 GeV^-2)*/



      
/*common neutmodel was here*/
/*common nemdls was here*/

/*WARNING: Ignoring include: #include <nieves1p1h.fh>*/
/*Line:#include <nieves1p1h.fh>*/
/* Include the corresponding *C.h file in your program */




/*------ common blocks -------------------------------------------------*/

extern struct neutmodel_common {
  int    modeldis;
  int    modelcoh;
  int    modeldif;
} neutmodel_;
#ifndef NO_EXTERN_COMMON_POINTERS
extern struct neutmodel_common *neutmodel;
#endif
#ifdef STATIC_COMMON_POINTERS
static struct neutmodel_common *neutmodel = &neutmodel_;
#endif

extern struct nemdls_common {
  int    mdlqe;
  int    mdlspi;
  int    mdldis;
  int    mdlcoh;
  int    mdldif;
  int    mdlqeaf;
  float  xmaqe;
  float  xmaspi;
  float  xmvqe;
  float  xmvspi;
  float  kapp;
  float  xmacoh;
  float  rad0nu;
  float  fa1coh;
  float  fb1coh;
  int    iffspi;
  int    nrtypespi;
  float  rca5ispi;
  float  rbgsclspi;
  float  xmares;
  float  xmvres;
  float  sccfv;
  float  sccfa;
  float  fpqe;
  float  pfsf;
  float  xmadif;
  float  nucvoldif;
  float  axffalpha;
  float  axffgamma;
  float  axfftheta;
  float  axffbeta;
  int    axzexpq4;
  int    axzexpnt;
  float  axzexpt0;
  float  axzexptc;
  float  axzexpa0;
  float  axzexpa1;
  float  axzexpa2;
  float  axzexpa3;
  float  axzexpa4;
  float  axzexpa5;
  float  axzexpa6;
  float  axzexpa7;
  float  axzexpa8;
  float  axzexpa9;
  int    mdl2p2h;
  float  xmancel;
} nemdls_;
#ifndef NO_EXTERN_COMMON_POINTERS
extern struct nemdls_common *nemdls;
#endif
#ifdef STATIC_COMMON_POINTERS
static struct nemdls_common *nemdls = &nemdls_;
#endif


/*------ data statements -----------------------------------------------*/


#ifndef NO_STATIC_DATA


#endif  /* #ifndef NO_STATIC_DATA */


/*------ end of fortran header -----------------------------------------*/


#ifdef __cplusplus
}
#endif


#endif  /* #ifndef FH2H_NEUTMODEL_H */
