/*
 * Generated automatically by fh2h.pl
 * !!! DO NOT EDIT !!!
 * Edit the original fortran header file instead
 * or fix fh2h.pl if there is a translation bug.
 */


#ifndef FH2H_FSIHIST_H
#define FH2H_FSIHIST_H


#ifdef __cplusplus
extern "C" {
#endif


#ifndef IMPLICIT
#define IMPLICIT  /* Only to point out implicit types */
#endif


/*------ fortran header (without commons and data statements) ----------*/

/*-------------------------------------------------------------*/
/**/
/*     INCLUDE FILE FOR NUCEFF VERTICES ( fsihist.h )*/
/**/
/*     WORK AREA OF M.C. VECTOR GENERATOR to store FSI vertices*/
/**/
/*-------------------------------------------------------------*/
#define MAXVERT (100)

#define MAXVCVERT (300)
/**/
/*     NVERT       : # OF VERTICES*/
/*     POSVERT(3,I): POSITION OF I-TH VERTEX*/
/*     IFLGVERT(I) : INTERACTION TYPE OF I-TH VERTEX */
/*                     (*10 FOR HI-NRG)*/
/*                     (*100 for SKDETSIM non-NEFFECT interactions e.g. elastic SGPIEL;*/
/*                          +0 Free Hydrogen, +1 Oxygen)*/
/*                  -1 : ESCAPE*/
/*                   0 : INITIAL (or unmatched parent vertex if I>1)*/
/*                   1 :*/
/*                   2 : */
/*                   3 : ABSORPTION*/
/*                   4 : CHARGE EXCHANGE*/
/*                   5 : */
/*                   6 : */
/*                   7 : HADRON PRODUCTION (hi-nrg only, i.e. 70)*/
/*                   8 : QUASI-ELASTIC SCATTER*/
/*                   9 : FORWARD (ELASTIC-LIKE) SCATTER*/
/**/
/*     NVCVERT     : # OF INTERMEDIATE PARTICLES*/
/*     DIRVERT(3,J): DIRECTION OF J-TH PARTICLE*/
/*     ABSPVERT(J) : ABSOLUTE MOM. OF J-TH PART. in lab frame (MeV/c)*/
/*     ABSTPVERT(J): ABSOLUTE MOM. OF J-TH PART. in nucleon rest frame */
/*     IPVERT(J)   : PARTICLE CODE OF J-TH PARTICLE*/
/*     IVERTI(J)   : INDEX OF INITIAL VERTEX OF J-TH PARTICLE*/
/*     IVERTF(J)   : INDEX OF FINAL VERTEX OF J-TH PARTICLE*/
/**/
/*common fsihist was here*/



/*------ common blocks -------------------------------------------------*/

extern struct fsihist_common {
  int    nvert;
  float  posvert[MAXVERT][3];
  int    iflgvert[MAXVERT];
  int    nvcvert;
  float  dirvert[MAXVCVERT][3];
  float  abspvert[MAXVCVERT];
  float  abstpvert[MAXVCVERT];
  int    ipvert[MAXVCVERT];
  int    iverti[MAXVCVERT];
  int    ivertf[MAXVCVERT];
  float  fsiprob;
} fsihist_;
#ifndef NO_EXTERN_COMMON_POINTERS
extern struct fsihist_common *fsihist;
#endif
#ifdef STATIC_COMMON_POINTERS
static struct fsihist_common *fsihist = &fsihist_;
#endif


/*------ data statements -----------------------------------------------*/


#ifndef NO_STATIC_DATA


#endif  /* #ifndef NO_STATIC_DATA */


/*------ end of fortran header -----------------------------------------*/


#ifdef __cplusplus
}
#endif


#endif  /* #ifndef FH2H_FSIHIST_H */
